//+------------------------------------------------------------------+
//|                                                      MARE5.1.mq4 |
//|                                        Author: Kvant & Reshetov  |
//|                                                                  |
//+------------------------------------------------------------------+
extern double Lots=7.8;
extern int       risk=10;                             // risk to calculate the lots size (only if mm is enabled)
extern double    DecreaseFactor=5;
extern double TakeProfit   = 110;
extern double StopLoss     = 80;
extern int    MAFastPeriod = 13;
extern int    MASlowPeriod = 55;
extern double MovingShift  = 2;
double cnt=0;
extern double TimeOpen     = 08;
extern double TimeClose    = 14;
extern int    maPos2       = 2;
extern int    maPos3       = 5;
//+------------------------------------------------------------------+
//| Start function                                                   |
//+------------------------------------------------------------------+
int start()
  {
   double FastMa=0;
   double FastMa2 = 0;
   double FastMa5 = 0;
   double SlowMa=0;
   double SlowMa2 = 0;
   double SlowMa5 = 0;
   FastMa=iMA(NULL,0,MAFastPeriod,MovingShift,MODE_SMA,PRICE_CLOSE,1);
   FastMa2 = iMA(NULL, 0, MAFastPeriod, MovingShift, MODE_SMA, PRICE_CLOSE, maPos2);
   FastMa5 = iMA(NULL, 0, MAFastPeriod, MovingShift, MODE_SMA, PRICE_CLOSE, maPos3);
   SlowMa=iMA(NULL,0,MASlowPeriod,MovingShift,MODE_SMA,PRICE_CLOSE,1);
   SlowMa2 = iMA(NULL,0, MASlowPeriod, MovingShift, MODE_SMA, PRICE_CLOSE, maPos2);
   SlowMa5 = iMA(NULL,0, MASlowPeriod, MovingShift, MODE_SMA, PRICE_CLOSE, maPos3);
   if(Hour()>=TimeOpen && Hour()<=TimeClose)
     {
      for(cnt=0; cnt<OrdersTotal(); cnt++)
        {
         if(OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES)==false)
            break;
         //if(CurTime()-OrderOpenTime()<300) return(0); 
        }
      if(OrdersTotal()<1)
        {
         //---- sell conditions
         if((SlowMa-FastMa)>=Point && (FastMa2-SlowMa2)>=Point && 
            (FastMa5-SlowMa5)>=Point && Close[1]<Open[1])
           {
            OrderSend(Symbol(),OP_SELL,GetLots(StopLoss),Bid,3,Bid+StopLoss*Point,
                      Bid-TakeProfit*Point,0,0,Red);
            return;
           }
         //---- buy conditions
         if((FastMa-SlowMa)>=Point && (SlowMa2-FastMa2)>=Point && 
            (SlowMa5-FastMa5)>=Point && Close[1]>Open[1])
           {
            OrderSend(Symbol(),OP_BUY,GetLots(StopLoss),Ask,3,Ask-StopLoss*Point,
                      Ask+TakeProfit*Point,0,0,Blue);
            return;
           }
        }
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double GetLots(double _sl)
  {

   double lot=Lots;
   double MinLots=MarketInfo(Symbol(),MODE_MINLOT);
   double MaxLots=MarketInfo(Symbol(),MODE_MAXLOT);
   double TickVal=MarketInfo(Symbol(),MODE_TICKVALUE);
   int    orders=HistoryTotal();     // history orders total
   int    losses=0;                  // number of losses orders without a break
   int digLots=0;
   if(MinLots<0.1)digLots=2;
   else
      if(MinLots<1)digLots=1;
//--- select lot size
   if(_sl<=0)_sl=iATR(Symbol(),PERIOD_D1,8,1)/Point;
   if(risk>0) lot=NormalizeDouble(AccountFreeMargin()*risk/100/TickVal/_sl,digLots);
//--- calcuulate number of losses orders without a break
   if(DecreaseFactor!=0)
     {
      for(int i=orders-1;i>=0;i--)
        {
         if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false)
           {
            Print("Error in history!");
            break;
           }
         if(OrderSymbol()!=Symbol() || OrderType()>OP_SELL)
            continue;
         //---
         if(OrderProfit()>0) break;
         if(OrderProfit()<0) losses++;
        }
      if(losses>1)
         lot=NormalizeDouble(lot-lot*losses/DecreaseFactor,digLots);
     }
//--- return lot size
   return(MathMin(MaxLots,MathMax(MinLots,lot)));
  }
//+------------------------------------------------------------------+
